<!-- templates/index.html -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{{ .title }}</title>
    <link href="https://cdn.jsdelivr.net/npm/tailwindcss@2.2.19/dist/tailwind.min.css" rel="stylesheet">
    <script src="https://unpkg.com/htmx.org"></script>
</head>

<body>
<h1 class="text-3xl font-bold underline text-gray-800 my-4">{{ .title }}</h1>

<!-- Information Section -->
<div class="mt-6 p-4 bg-white rounded-lg border border-gray-200 shadow-md">
    <h2 class="text-lg font-semibold text-gray-900">Over het Standaardenregister</h2>
    <p class="mt-2 text-gray-600">
        Welkom op het Dashboard van het standaardenregister. Plak hieronder je JWT om checks op te halen.

        Deze pagina is een WIP en moet ook op die wijze behandeld worden.
    </p>
    <div class="mt-4">
        <a href="/api/v1/schema" class="text-blue-600 hover:underline">OpenAPI Schema</a>
        <span class="mx-2">|</span>
        <a href="https://gitlab.com/commonground/haven/standaardenregister" class="text-blue-600 hover:underline">GitLab Page</a>
    </div>
</div>

<div class="mb-4">
    <input type="text" id="jwt-token" placeholder="Paste your JWT here" class="border p-4 text-lg mr-2 w-full md:w-1/2">
    <button onclick="setJwt()" class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded">Set JWT</button>
</div>

<div>
    <button onclick="fetchAllChecks()" class="bg-green-500 hover:bg-green-700 text-white font-bold py-2 px-4 rounded">Fetch All Checks</button>
</div>

<div id="jwt-display" class="mb-4 p-2 bg-gray-100 text-gray-800 rounded"></div>

<!-- Placeholder for the checks list; actual content loaded by HTMX -->
<div id="checks-list" hx-get="/api/v1/checks" hx-trigger="every 30s" class="mt-4">
    Loading checks...
</div>

<script>
    function setJwt() {
        var jwt = document.getElementById('jwt-token').value;
        if (jwt) {
            htmx.ajax('GET', '/api/v1/checks', {
                headers: {'Authorization': 'Bearer ' + jwt},
                target: '#checks-list'
            });

            document.getElementById('jwt-display').textContent = 'JWT: ' + jwt;

            document.querySelectorAll('[hx-get]').forEach(function(el) {
                el.setAttribute('hx-headers', JSON.stringify({'Authorization': 'Bearer ' + jwt}));
            });

            // the trigger is started here to automatically load all the checks every 30s
            htmx.trigger("#checks-list", "load");
        }
    }
    function fetchAllChecks() {
        var jwt = document.getElementById('jwt-token').value;
        if (!jwt) {
            alert("Please set the JWT first.");
            return;
        }

        document.getElementById('jwt-display').textContent = 'JWT: ' + jwt;

        htmx.ajax('GET', '/api/v1/checks', {
            headers: {'Authorization': 'Bearer ' + jwt},
            target: '#checks-list'
        });
    }
</script>

</body>
</html>
